'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _fluxStandardAction = require('flux-standard-action');

var _reactGa = require('react-ga');

var _reactGa2 = _interopRequireDefault(_reactGa);

function defaultTracking(payload, state, action) {
  // if(payload  && action && !payload.action){
  //   payload.action = action.type;
  // }

  _reactGa2['default'].event(payload);
}

exports['default'] = function () {
  var track = arguments.length <= 0 || arguments[0] === undefined ? defaultTracking : arguments[0];
  var select = arguments.length <= 1 || arguments[1] === undefined ? function (_ref) {
    var meta = _ref.meta;
    return meta.analytics;
  } : arguments[1];
  return function (store) {
    return function (next) {
      return function (action) {
        var returnValue = next(action);

        if (!action || !action.meta) {
          return returnValue;
        }

        var event = select(action);

        if (!event) {
          return returnValue;
        }

        if (!(0, _fluxStandardAction.isFSA)(event)) {
          var message = "The following event wasn't tracked because it isn't a Flux Standard Action (https://github.com/acdlite/flux-standard-action)";
          console.error(message, event);
          return returnValue;
        }

        track(event, store.getState(), action);

        return returnValue;
      };
    };
  };
};

module.exports = exports['default'];